/** 
 * @file   Character.cpp
 * @author: yannick
 * 
 * @date 21 feb 2022, 12:07
 */

#include "Character.h"


namespace Oop
{
   Character::Character(sf::Texture * texture, 
                        sf::IntRect * rectSprite, 
                        float x, 
                        float y, 
                        Game * g):
   Element(texture,rectSprite,x,y,g),_moveX(0),_moveY(0)
   {setCollider(16,16,rectSprite->width - (rectSprite->width/2),rectSprite->height - (rectSprite->height/3));}
   
    Character::~Character() {}

    void Character::setMovement(float x, float y)
    {
        _moveX = x;
        _moveY = y;
    }
    
    void Character::dontMove()
    {
        _moveX = 0;
        _moveY = 0;
    } 
    
    void Character::updatePosition()
    {
        move(_moveX,_moveY);
    }
};