/** 
 * @file   SettingData.cpp
 * @author Yannick Pencolé
 * @date   19 feb. 2022, 00:04
 **/

#include <map>
#include "SettingData.h"

namespace Oop
{
    
    SettingData::SettingData():_colliders(),_textureRectangles(){}
    
    SettingData::~SettingData(){}
    
    sf::IntRect * SettingData::collider(SettingType type)
    {
        return &_colliders.at(type);
    }
    
    sf::IntRect * SettingData::textureRect(SettingType type)
    {
        return &_textureRectangles.at(type);  
    }

    void SettingData::setCollider(SettingType type, int left,int top,int width,int height)
    {
        _colliders.emplace(type,sf::IntRect(left,top,width,height));
    }
    
    void SettingData::setTextureRect(SettingType type,int left,int top,int width,int height)
    {
          _textureRectangles.emplace(type,sf::IntRect(left,top,width,height));
    }
    
    
    SettingData createSettingData()
    {
        SettingData result;
        result.setTextureRect(SettingType::TREE1,224, 224, 128, 128);
        result.setCollider(SettingType::TREE1, 32, 80, 64, 32);
        result.setTextureRect(SettingType::TREE2,352, 224, 128, 128);
        result.setCollider(SettingType::TREE2, 16, 80 , 64, 32);
        result.setTextureRect(SettingType::WOODPILE1, 0, 352, 32, 64);
        result.setCollider(SettingType::WOODPILE1,0, 0, 0, 0);
        result.setTextureRect(SettingType::WOODPILE2,32, 352, 64, 64);
        result.setCollider(SettingType::WOODPILE2,0, 0, 0, 0);
        result.setTextureRect(SettingType::WOODPILE3, 96, 352, 64, 64);
        result.setCollider(SettingType::WOODPILE3,16, 32, 32, 32);
        result.setTextureRect(SettingType::LOG,160, 352, 32, 32);
        result.setCollider(SettingType::LOG,0, 0, 0, 0);
        result.setTextureRect(SettingType::ANVIL,192, 352, 32, 32);
        result.setCollider(SettingType::ANVIL,0, 0, 0, 0);
        return result;
    }
}
