/** 
 * @file  main.cpp
 * @author ??
 *  
 **/

#include <cstdlib>
#include "SettingData.h"
#include "Game.h"

using namespace std;

void initialiseRandomGenerator() {
    time_t t;
    srand((unsigned) time(&t));
}

/*
 * 
 */
int main(int argc, char** argv) {
    initialiseRandomGenerator();
    Oop::SettingData data = Oop::createSettingData();
    sf::Texture settingTexture;
    settingTexture.loadFromFile("settings.png");
    Oop::Game game(800,600,"TP POO Game");
    game.newSetting(Oop::SettingType::TREE1,
            &settingTexture,
            data.textureRect(Oop::SettingType::TREE1),
            data.collider(Oop::SettingType::TREE1),
            300, 200);
    game.newSetting(Oop::SettingType::TREE2,
            &settingTexture,
            data.textureRect(Oop::SettingType::TREE2),
            data.collider(Oop::SettingType::TREE2),
            400, 100);
    game.newSetting(Oop::SettingType::ANVIL,
            &settingTexture,
            data.textureRect(Oop::SettingType::ANVIL),
            data.collider(Oop::SettingType::ANVIL),
            500, 100);
    game.newSetting(Oop::SettingType::LOG,
            &settingTexture,
            data.textureRect(Oop::SettingType::LOG),
            data.collider(Oop::SettingType::LOG),
            700, 100);
    game.newSetting(Oop::SettingType::WOODPILE1,
            &settingTexture,
            data.textureRect(Oop::SettingType::WOODPILE1),
            data.collider(Oop::SettingType::WOODPILE1),
            700, 400);
    game.newSetting(Oop::SettingType::WOODPILE2,
            &settingTexture,
            data.textureRect(Oop::SettingType::WOODPILE2),
            data.collider(Oop::SettingType::WOODPILE2),
            100, 400);
    game.newSetting(Oop::SettingType::WOODPILE3,
            &settingTexture,
            data.textureRect(Oop::SettingType::WOODPILE3),
            data.collider(Oop::SettingType::WOODPILE3),
            200, 400);
    sf::Texture heroes;
    sf::IntRect heroRect(0, 128, 64, 64);
    heroes.loadFromFile("hero.png");
    game.newHero(&heroes, &heroRect, 250, 450);


    sf::Texture monsterTexture;
    monsterTexture.loadFromFile("monster1.png");
    sf::IntRect monsterRect(0, 0, 64, 64);
    game.newMonster(&monsterTexture, &monsterRect, 300, 40);
    game.newMonster(&monsterTexture, &monsterRect, 600, 40);
    game.newMonster(&monsterTexture, &monsterRect, 300, 300);
    game.newMonster(&monsterTexture, &monsterRect, 300, 40);
    game.newMonster(&monsterTexture, &monsterRect, 600, 40);
    game.newMonster(&monsterTexture, &monsterRect, 300, 300);
    game.newMonster(&monsterTexture, &monsterRect, 300, 40);
    game.newMonster(&monsterTexture, &monsterRect, 600, 40);
    game.newMonster(&monsterTexture, &monsterRect, 300, 300);
    game.newMonster(&monsterTexture, &monsterRect, 300, 40);
    game.newMonster(&monsterTexture, &monsterRect, 600, 40);
    game.newMonster(&monsterTexture, &monsterRect, 300, 300);
    game.run();
    return 0;
}

